/*============================================================================
/ psionfs_file.h
/ © Michael Pieper 15. Oct. 2000
/	  Last Change: 28. Oct. 2000 Michael Pieper
/============================================================================
/
/	This header-File includes all "File"-Functions for the PSION-FileSystem
/
/============================================================================*/

#ifndef PSIONFS_FILE_H
#define PSIONFS_FILE_H

#include "psionfs.h"			/* we have to include the filesystemspecific informations	*/

/*===========================================================================
/	The filefunctions such as cretae, open, close eg.
/============================================================================*/

int	psionfs_create		(void *ns, void *dir, const char *name,	int omode, int perms, vnode_id *vnid, void **cookie);

int psionfs_read		(void *ns, void *node, void *cookie, off_t pos, void *buf, size_t *len);
int	psionfs_write		(void *ns, void *node, void *cookie, off_t pos, const void *buf, size_t *len);

int psionfs_close		(void *ns, void *node, void *cookie);
int	psionfs_free_cookie	(void *ns, void *node, void *cookie);

int	psionfs_unlink		(void *ns, void *dir, const char *name);

int	psionfs_rstat		(void *ns, void *node, struct stat *st);
int	psionfs_wstat		(void *ns, void *node, struct stat *st, long mask);

#endif

