/*============================================================================
/ psionfs_rfsv.h
/ © Michael Pieper 21. Oct. 1999
/     Last change: 11. Nov. 2000 Michael Pieper
/============================================================================
/
/	This Header-File includes all Definitions of the RFSV-Protocoll
/
/============================================================================*/

#ifndef PSIONFS_RFSV_H
#define PSIONFS_RFSV_H

#include "psionfs.h"

/*===========================================================================
/	We have to specify the filesystemfunctions
/============================================================================*/

int 	psion_close		(nspace *ns, dircookie *cookie);
ssize_t psion_read		(nspace *ns, dircookie *cookie, char *buf, 			size_t length);
ssize_t psion_write		(nspace *ns, dircookie *cookie, const char *buf, 	size_t length);
int		psion_fseek		(nspace *ns, dircookie *cookie, int seekmode, 		ssize_t offset);
int		psion_rename	(nspace *ns, const char *old_file, const char *new_file);
int		psion_delete	(nspace *ns, const char *file);
int		psion_sfstat	(nspace *ns, const char *file, uint16 status,		uint16 mask);
int		psion_mkdir		(nspace *ns, const char *folder);
int		psion_sfdate	(nspace *ns, const char *file, uint32 seconds);

#endif